$
$ set noon
$ __		= "write sys$output"
$ chksts	= "if .not. $status then exit $status"
$
$ if p1 .eqs. "" then exit
$
$ file_spec	= f$search(p1)
$ if file_spec .eqs. "" then goto bad_file
$
$ format	= f$file_attributes(file_spec, "ORG")
$ if format .nes. "IDX" then goto bad_format
$
$ old_alq	= f$file_attributes(file_spec, "ALQ")
$ old_bks	= f$file_attributes(file_spec, "BKS")
$ old_cbt	= f$file_attributes(file_spec, "CBT")
$ old_deq	= f$file_attributes(file_spec, "DEQ")
$ old_uic	= f$file_attributes(file_spec, "UIC")
$
$ file_name	= f$parse(file_spec,,,"NAME")
$ location	= f$parse(file_spec,,,"DEVICE") + -
		  f$parse(file_spec,,,"DIRECTORY")
$ file_type	= f$parse(file_spec,,,"TYPE")
$
$ new_spec	= "SYS$SCRATCH:''file_name'_NEW''file_type'"
$ anl_spec	= "SYS$SCRATCH:''file_name'_ANL.FDL"
$ fdl_spec	= "SYS$SCRATCH:''file_name'.FDL"
$ ren_spec	= "''location'''file_name'_NEW''file_type'"
$
$ gosub cleanup
$
$ new_disp	= "''file_name'_NEW''file_type'"
$ old_disp	= "''file_name'''file_type'"
$
$ __ " * Analyzing ''old_disp'"
$ analyze/rms/fdl/out='anl_spec' 'file_spec'
$ chksts
$
$ __ " * Creating new FDL for ''file_name'''file_type'"
$ copy 'anl_spec' 'fdl_spec'
$ chksts
$
$ edit/fdl/ana='anl_spec'/nointer 'fdl_spec'
$ chksts
$
$ __ " * Converting ''old_disp' to ''new_spec'"
$ convert/stat/fdl='fdl_spec' 'file_spec' 'new_spec'
$ chksts
$
$ __ " * Backing up ''new_spec' to ''location'"
$ backup 'new_spec' 'ren_spec'/own='old_uic'
$
$ new_exists	= f$search(ren_spec) .nes. ""
$ if .not. new_exists then goto abort
$
$ __ " * Deleting old ''old_disp'"
$ set prot=(s:rwed, o:rwed) 'file_spec'
$ delete/noconf 'file_spec'
$ chksts
$
$ __ " * Renaming ''new_disp' to ''old_disp'"
$ new_pro	= f$file_attributes(ren_spec, "PRO")
$ set prot=(s:rwed, o:rwed) 'ren_spec'
$ rename 'ren_spec' 'file_spec'
$ set prot=('new_pro') 'file_spec'
$ chksts
$
$ new_alq	= f$file_attributes(file_spec, "ALQ")
$ new_bks	= f$file_attributes(file_spec, "BKS")
$ new_cbt	= f$file_attributes(file_spec, "CBT")
$ new_deq	= f$file_attributes(file_spec, "DEQ")
$
$ __ " * Conversion Information for ''file_name'''file_type':"
$ __ "   ALQ (Allocation)              = ''new_alq' from ''old_alq'"
$ __ "   BKS (Bucket Size)             = ''new_bks' from ''old_bks'"
$ __ "   CBT (Contiguous Best Try)     = ''new_cbt' from ''old_cbt'"
$ __ "   DEQ (Default Extend Quantity) = ''new_deq' from ''old_deq'"
$ __ ""
$
$ gosub cleanup
$ goto finish
$
$ abort:
$   __ "Rebuild failed..."
$   __ "   New file doesn't exist."
$   __ "   Old file remains unchanged."
$   if f$mode() .eqs. "BATCH" then goto batch_abort
$   inquire/nopunct dmy "   Do you want to cleanup SYS$SCRATCH [Y]?  "
$   cleanup	= dmy .or. (dmy .eqs. "")
$   if cleanup then gosub cleanup
$   goto finish
$
$ batch_abort:
$   type 'anl_spec'
$   type 'fdl_spec'
$   gosub cleanup
$   goto finish
$
$ bad_file:
$   __ "''p1' does not translate to a valid file specification."
$   goto finish
$
$ bad_format:
$   __ "''p1' is not an indexed file."
$   goto finish
$
$ finish:
$   set on
$   exit
$
$ cleanup:
$    if (f$search(new_spec) .nes. "") then -
	set prot=(s:rwed, o:rwed) 'new_spec';*
$    if (f$search(new_spec) .nes. "") then delete/nolog/noconf 'new_spec';*
$    if (f$search(anl_spec) .nes. "") then delete/nolog/noconf 'anl_spec';*
$    if (f$search(fdl_spec) .nes. "") then delete/nolog/noconf 'fdl_spec';*
$    return
$
